unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, memds, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Spin, DBGrids, IBCustomDataSet, IBTable, DateTimePicker, rxmemds, rxdbgrid,
  rxcurredit, variants;

type
  //вариант действия сендера для редактирования записи (добавление/редактирование/удаление)
  TSendActMode = (samAdd, samEdt, samDel);
  { TForm1 }

  TForm1 = class(TForm)
    btnAdd: TButton;
    btnEdt: TButton;
    btnDel: TButton;
    btnLeft: TButton;
    btnRight: TButton;
    CheckBox1: TCheckBox;
    CurEdt: TCurrencyEdit;
    DS: TDataSource;
    DateTimePicker1: TDateTimePicker;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    MDBoolFld: TBooleanField;
    MDCurr: TCurrencyField;
    MDDTFld: TDateTimeField;
    MDID: TAutoIncField;
    MDIntFld: TLongintField;
    MDMemo: TMemoField;
    MDStrFld: TStringField;
    Memo1: TMemo;
    DBGrid: TRxDBGrid;
    MD: TRxMemoryData;
    SpinEdit1: TSpinEdit;
    procedure btnAddClick(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
    procedure btnEdtClick(Sender: TObject);
    procedure btnLeftClick(Sender: TObject);
    procedure btnRightClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure InitMode(Sender: TObject);
    procedure EditMode(Sender: TObject);
  private
    FSendActMode: TSendActMode;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF LINUX}
  btnLeft.Caption:= 'Отмена';
  btnRight.Caption:= 'Сохранить';
  {$ELSE}
  btnLeft.Caption:= 'Сохранить';
  btnRight.Caption:= 'Отмена';
  {$ENDIF}
end;

procedure TForm1.btnLeftClick(Sender: TObject);
begin
  {$IFDEF LINUX}
  if FSendActMode = samEdt then MD.Cancel;
  {$ELSE}
  case FSendActMode of
    samAdd:
      MD.AppendRecord([nil,CheckBox1.Checked,Edit1.Text,
                      DateTimePicker1.DateTime,SpinEdit1.Value,
                      Memo1.Text,CurEdt.Value]);
    samEdt:
      begin
        MD.Delete;
        MD.InsertRecord([nil,CheckBox1.Checked,Edit1.Text,
                        DateTimePicker1.DateTime,SpinEdit1.Value,
                        Memo1.Text,CurEdt.Value]);
      end;
  //  samDel:
  //    begin
  //      MD.Delete;
  //    end;
  end;
  {$ENDIF}

  InitMode(Sender);
end;

procedure TForm1.btnAddClick(Sender: TObject);
begin
  FSendActMode:= samAdd;//добавляем запись
  EditMode(Sender);
end;

procedure TForm1.btnDelClick(Sender: TObject);
begin
  //FSendActMode:= samDel;//удаляем запись
  MD.Delete;
  InitMode(Sender);
end;

procedure TForm1.btnEdtClick(Sender: TObject);
begin
  FSendActMode:= samEdt;//изменяем запись
  EditMode(Sender);
end;

procedure TForm1.btnRightClick(Sender: TObject);
begin
  {$IFDEF LINUX}
  case FSendActMode of
    samAdd:
      MD.AppendRecord([CheckBox1.Checked,Edit1.Text,
                      DateTimePicker1.DateTime,SpinEdit1.Value,
                      Memo1.Text,CurEdt.Value]);
    samEdt:
      begin
        MD.Delete;
        MD.InsertRecord([CheckBox1.Checked,Edit1.Text,
                        DateTimePicker1.DateTime,SpinEdit1.Value,
                        Memo1.Text,CurEdt.Value]);
      end;
    //samDel:
    //  begin
    //    MD.Delete;
    //  end;
  end;
  {$ELSE}
  if FSendActMode = samEdt then MD.Cancel;
  {$ENDIF}

  InitMode(Sender);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  MD.Open;
  InitMode(Sender);
end;

procedure TForm1.InitMode(Sender: TObject);
begin
  MD.EnableControls;

  if MD.IsEmpty
    then DS.DataSet:= nil
    else DS.DataSet:= MD;

  GroupBox1.Visible:= False;
  btnAdd.Enabled:= True;
  btnEdt.Enabled:= not MD.IsEmpty;
  btnDel.Enabled:= not MD.IsEmpty;
  DBGrid.Enabled:= not MD.IsEmpty;
  //DBGrid.SelectedColor:=;

  if DBGrid.Enabled
    then
      DBGrid.TitleFont.Color:= clDefault
    else
      DBGrid.TitleFont.Color:= clGray;

end;

procedure TForm1.EditMode(Sender: TObject);
begin
  MD.DisableControls;

  GroupBox1.Visible:= True;
  btnAdd.Enabled:= not GroupBox1.Visible;
  btnEdt.Enabled:= not GroupBox1.Visible;
  btnDel.Enabled:= not GroupBox1.Visible;
  DBGrid.Enabled:= not GroupBox1.Visible;

  case FSendActMode of
    samAdd:
      begin
        CheckBox1.Checked:= False;
        Edit1.Clear;
        DateTimePicker1.DateTime:= Now;
        SpinEdit1.Value:= 0;
        Memo1.Clear;
        CurEdt.Value:= 0;
      end;
    samEdt:
      begin
        CheckBox1.Checked:= MD.FieldValues['BoolFld'];
        Edit1.Text:= VarToStr(MD.FieldValues['StrFld']);
        DateTimePicker1.DateTime:= MD.FieldValues['DTFld'];
        SpinEdit1.Value:= MD.FieldValues['IntFld'];
        Memo1.Text:= VarToStr(MD.FieldValues['Memo']);
        CurEdt.Value:= MD.FieldValues['Curr'];
      end;
  end;
end;

end.

